package com.mortals.xhx.module.certificate.service.impl;
import com.mortals.xhx.common.code.StatusEnum;
import com.mortals.xhx.module.certificate.model.CertificateChildEntity;
import com.mortals.xhx.module.certificate.model.CertificateChildQuery;
import com.mortals.xhx.module.certificate.model.CertificateDocumentQuery;
import com.mortals.xhx.module.certificate.service.CertificateChildService;
import org.springframework.beans.BeanUtils;

import java.util.List;
import java.util.function.Function;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.xhx.module.certificate.dao.CertificateDocumentDao;
import com.mortals.xhx.module.certificate.model.CertificateDocumentEntity;
import com.mortals.xhx.module.certificate.service.CertificateDocumentService;
import lombok.extern.slf4j.Slf4j;
/**
* CertificateDocumentService
* 子证配置 service实现
*
* @author zxfei
* @date 2024-07-27
*/
@Service("certificateDocumentService")
@Slf4j
public class CertificateDocumentServiceImpl extends AbstractCRUDServiceImpl<CertificateDocumentDao, CertificateDocumentEntity, Long> implements CertificateDocumentService {

    @Autowired
    private CertificateChildService certificateChildService;

    @Override
    public List<CertificateDocumentEntity> getListByCatalogId(Long catalogId) {
        List<CertificateChildEntity> childEntityList = certificateChildService.find(new CertificateChildQuery().catalogId(catalogId));
        List<Long> documentIdList = childEntityList.stream().map(CertificateChildEntity::getDocumentId).collect(Collectors.toList());
        List<CertificateDocumentEntity> documentEntityList = this.find(new CertificateDocumentQuery().idList(documentIdList).status(StatusEnum.ENABLE.getValue()));
        return documentEntityList;
    }
}